/* E2A
   copies an EBCDIC file to ASCII			
*/

static unsigned char hashArray[256] = {
   0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 
     0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F,
     0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17,
     0x18, 0x19, 0x1A, 0x1B, 0x1C, 0x1D, 0x1E, 0x1F,
     0x20, 0x21, 0x22, 0x23, 0x24, 0x25, 0x26, 0x27,
     0x28, 0x29, 0x2A, 0x2B, 0x2C, 0x2D, 0x2E, 0x2F,
     0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37,
     0x38, 0x39, 0x3A, 0x3B, 0x3C, 0x3D, 0x3E, 0x3F,
     ' ', 0x41, 0x42, 0x43, 0x44, 0x45, 0x46, 0x47,
     0x48, 0x49, 0x4A, '.', '<', '(', '+', '|',
     '&', 0x51, 0x52, 0x53, 0x54, 0x55, 0x56, 0x57,
     0x58, 0x59, '!', '$', '*', ')', ';', '^', // ^ maybe should be 0x5F
     '-', '/', 0x62, 0x63, 0x64, 0x65, 0x66, 0x67,
     0x68, 0x69, '|', ',', '%', '_', '>', '?',
     0x70, 0x71, 0x72, 0x73, 0x74, 0x75, 0x76, 0x77,
     0x78, '`', ':', '#', '@', '\'', '=', '"',
     0x80, 'a', 'b', 'c', 'd', 'e', 'f', 'g',
     'h', 'i', 0x8A, 0x8B, 0x8C, 0x8D, 0x8E, 0x8F,
     0x90, 'j', 'k', 'l', 'm', 'n', 'o', 'p',
     'q', 'r', 0x9A, 0x9B, 0x9C, 0x9D, 0x9E, 0x9F,
     0xA0, '~', 's', 't', 'u', 'v', 'w', 'x',
     'y', 'z', 0xAA, 0xAB, 0xAC, 0xAD, 0xAE, 0xAF,
     0xB0, 0xB1, 0xB2, 0xB3, 0xB4, 0xB5, 0xB6, 0xB7,
     0xB8, 0xB9, 0xBA, 0xBB, 0xBC, 0xBD, 0xBE, 0xBF,
     '{', 'A', 'B', 'C', 'D', 'E', 'F', 'G',
     'H', 'I', 0xCA, 0xCB, 0xCC, 0xCD, 0xCE, 0xCF,
     '}', 'J', 'K', 'L', 'M', 'N', 'O', 'P',
     'Q', 'R', 0xDA, 0xDB, 0xDC, 0xDD, 0xDE, 0xDF,
     '\\', 0xE1, 'S', 'T', 'U', 'V', 'W', 'X',
     'Y', 'Z', 0xEA, 0xEB, 0xEC, 0xED, 0xEE, 0xEF,
     '0', '1', '2', '3', '4', '5', '6', '7',
     '8', '9', 0xFA, 0xFB, 0xFC, 0xFD, 0xFE, 0xFF
};

void EBCDIC_to_ASCII(char *src, unsigned int len)
{
   while (len-- > 0) 
     {
	*src = hashArray[*src & 0xFF];
	src ++;
     }
}
